module CLOCK(SEG,SEL,CLK);
output[7:0] SEG;
output[5:0] SEL;
input CLK;
//-----------------------
reg[7:0] SEG_REG;
reg[3:0] SEG_BUF;
reg[5:0] SEL_REG;
reg[13:0] DIS_COUNTER;
reg[23:0] TIME_COUNTER;
reg[2:0] DIS_STATUS;
reg[7:0] HOUR,MIN,SEC;
reg SEC_FLAG;
//-----------------------------
always@(posedge CLK)
 begin
   TIME_COUNTER=TIME_COUNTER+1'b1;
   if(TIME_COUNTER==24'd12000000)
	begin
	 TIME_COUNTER=24'd0;
	 SEC_FLAG=~SEC_FLAG;
	end
end		
//----------------------------------------------- 
always@(posedge SEC_FLAG)
 begin
      SEC[3:0]=SEC[3:0]+1'b1;
		  if(SEC[3:0]==4'd10)
		  begin
          SEC[3:0]=4'd0;
          SEC[7:4]=SEC[7:4]+1'b1;
          //---------------------------------
            if(SEC[7:4]==4'd6)
		      begin
		        SEC[7:4]=4'd0;
		        MIN[3:0]=MIN[3:0]+1'b1;
		   	  //----------------------------------------
		      if(MIN[3:0]==4'd10)
		        begin
				 MIN[3:0]=4'd0;
				 MIN[7:4]=MIN[7:4]+1'b1;
			     //----------------------------------------
			     if(MIN[7:4]==4'd6)
			       begin
		            MIN[7:4]=4'd0;
		            HOUR[3:0]=HOUR[3:0]+1'b1;
		       		  //---------------------------------------
		       		  if((HOUR[7:4]==4'd2)&&(HOUR[3:0]==4'd4))
						    begin
							  HOUR[7:4]=4'd0;
							  HOUR[3:0]=4'd0;
						    end 
		              else if(HOUR[3:0]==4'd10)
						    begin
						      HOUR[3:0]=4'd0;
						      HOUR[7:4]=HOUR[7:4]+1'b1;
			   		        end
		           end
		        end
		      end
		  end
 end
//-------------------------------  
always@(posedge CLK)
 begin
   DIS_COUNTER<=DIS_COUNTER+1'b1;
     if(DIS_COUNTER==14'b11111111111111)
		begin
		DIS_STATUS=DIS_STATUS+1'b1;
		  if(DIS_STATUS==3'd6)DIS_STATUS=0;
		end
  end
//-----------------------------
always@(posedge CLK)
 begin
   case(DIS_STATUS)	
   3'd0:SEG_BUF<=SEC[3:0];	
   3'd1:SEG_BUF<=SEC[7:4];
   3'd2:SEG_BUF<=MIN[3:0];
   3'd3:SEG_BUF<=MIN[7:4];			
   3'd4:SEG_BUF<=HOUR[3:0];
   3'd5:SEG_BUF<=HOUR[7:4];	
   endcase	
 end 
//-----------------------------
always@(posedge CLK)
 begin
   case(SEG_BUF)	
   4'd0:SEG_REG<=8'h3f;	
   4'd1:SEG_REG<=8'h06;	
   4'd2:SEG_REG<=8'h5b;	
   4'd3:SEG_REG<=8'h4f;	
   4'd4:SEG_REG<=8'h66;	
   4'd5:SEG_REG<=8'h6d;	
   4'd6:SEG_REG<=8'h7d;	
   4'd7:SEG_REG<=8'h07;
   4'd8:SEG_REG<=8'h7f;
   4'd9:SEG_REG<=8'h6f;
   default:SEG_REG<=8'hzz;
   endcase	
 end 
//-----------------------------
always@(posedge CLK)
 begin
   case(DIS_STATUS)	
   3'd0:SEL_REG<=8'b00000001;	
   3'd1:SEL_REG<=8'b00000010;	
   3'd2:SEL_REG<=8'b00000100;	
   3'd3:SEL_REG<=8'b00001000;	
   3'd4:SEL_REG<=8'b00010000;	
   3'd5:SEL_REG<=8'b00100000;
   default:SEL_REG<=6'hzz;
   endcase	
 end
//----------------------------- 
 assign SEG=SEG_REG;
 assign SEL=SEL_REG;
endmodule

