////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 1995-2003 Xilinx, Inc.
// All Right Reserved.
////////////////////////////////////////////////////////////////////////////////
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /    Vendor: Xilinx 
// \   \   \/     Version : 9.1i
//  \   \         Application : ISE
//  /   /         Filename : decoder2_4_test_selfcheck.tfw
// /___/   /\     Timestamp : Sun Mar 07 12:37:05 2010
// \   \  /  \ 
//  \___\/\___\ 
//
//Command: 
//Design Name: decoder2_4_test_selfcheck_beh
//Device: Xilinx
//
`timescale 1ns/1ps

module decoder2_4_test_selfcheck_beh;
    wire [3:0] LED;
    reg [1:0] S = 2'b00;


    decoder2_4 UUT (
        .LED(LED),
        .S(S));

    integer TX_ERROR = 0;
    
    initial begin  // Open the results file...
        #1000 // Final time:  1000 ns
        if (TX_ERROR == 0) begin
            $display("No errors or warnings.");
        end else begin
            $display("%d errors found in simulation.", TX_ERROR);
        end
        $stop;
    end

    initial begin
        // -------------  Current Time:  200ns
        #200;
        S = 2'b01;
        // -------------------------------------
        // -------------  Current Time:  250ns
        #50;
        CHECK_LED(4'b0010);
        // -------------------------------------
        // -------------  Current Time:  300ns
        #50;
        S = 2'b10;
        // -------------------------------------
        // -------------  Current Time:  350ns
        #50;
        CHECK_LED(4'b0100);
        // -------------------------------------
        // -------------  Current Time:  400ns
        #50;
        S = 2'b11;
        // -------------------------------------
        // -------------  Current Time:  450ns
        #50;
        CHECK_LED(4'b1000);
        // -------------------------------------
        // -------------  Current Time:  500ns
        #50;
        S = 2'b00;
        // -------------------------------------
        // -------------  Current Time:  550ns
        #50;
        CHECK_LED(4'b0001);
        // -------------------------------------
        // -------------  Current Time:  700ns
        #150;
        S = 2'b01;
        // -------------------------------------
        // -------------  Current Time:  750ns
        #50;
        CHECK_LED(4'b0010);
        // -------------------------------------
        // -------------  Current Time:  800ns
        #50;
        S = 2'b11;
        // -------------------------------------
        // -------------  Current Time:  850ns
        #50;
        CHECK_LED(4'b1000);
        // -------------------------------------
        // -------------  Current Time:  900ns
        #50;
        S = 2'b10;
        // -------------------------------------
        // -------------  Current Time:  950ns
        #50;
        CHECK_LED(4'b0100);
    end

    task CHECK_LED;
        input [3:0] NEXT_LED;

        #0 begin
            if (NEXT_LED !== LED) begin
                $display("Error at time=%dns LED=%b, expected=%b", $time, LED, NEXT_LED);
                TX_ERROR = TX_ERROR + 1;
            end
        end
    endtask

endmodule

